import java.util.ArrayList;

// https://uva.onlinejudge.org/index.php?option=com_onlinejudge&Itemid=8&category=103&page=show_problem&problem=481
class Team {
	private String name;

	public Team(String name) {
		this.name = name;
	}
}

class Person {
	private String name;
	private Team team;

	public Person(String name, Team team) {
		this.name = name;
		this.team = team;
	}

	public String getName() {
		return name;
	}

	public Team getTeam() {
		return team;
	}
}

class Queue {
	protected ArrayList<Person> persons;

	public Queue() {
		persons = new ArrayList<Person>();
	}

	public void enqueue(Person p) {
		persons.add(p); // fügt hinten an
	}

	public Person dequeue() {
		return persons.remove(0); // entfernt und liefert vorderes Element
	}

	public boolean isEmpty() {
		return this.persons.isEmpty();
	}
}

class TeamQueue extends Queue {

	public void enqueue(Person p) {
		for (int i = 0; i < persons.size(); i++) {
			if (persons.get(i).getTeam() == p.getTeam()) { // Team vorhanden
				for (int j = i + 1; j < persons.size(); j++) {
					if (persons.get(j).getTeam() != p.getTeam()) { // insert vor naechstes Team
						persons.add(j, p);
						return;
					}
				}
				// Team ist letztes in der Queue
				persons.add(p);
				return;
			}
		}
		// Team bisher nicht in Queue vorhanden
		persons.add(p);
	}
}

public class UE16Aufgabe16 {
	public static void main(String[] args) {
		Team team1 = new Team("Maenner");
		Team team2 = new Team("Frauen");
		TeamQueue queue = new TeamQueue();
		queue.enqueue(new Person("Karl", team1));
		queue.enqueue(new Person("Maria", team2));
		queue.enqueue(new Person("Otto", team1));
		queue.enqueue(new Person("Paula", team2));
		System.out.println(queue.dequeue().getName());
		System.out.println(queue.dequeue().getName());
		queue.enqueue(new Person("Kevin", team1));
		queue.enqueue(new Person("Karla", team2));
		while (!queue.isEmpty()) {
			System.out.println(queue.dequeue().getName());
		}
	}

}
