import java.util.ArrayList;

/**
 * A Last-In-First-Out(LIFO) stack of objects.
 */
class MyStack extends ArrayList<Integer> {
	/**
	 * Pushes an item onto the stack.
	 * 
	 * @param item
	 *            the item to be pushed on.
	 */
	void push(int item) {
		this.add(item);
	}

	/**
	 * Pops an item off the stack.
	 */
	int pop() {
		return this.remove(this.size() - 1);
	}

	/**
	 * Peeks at the top of the stack.
	 */
	int peek() {
		return this.get(this.size() - 1);
	}

	/**
	 * Returns true if the stack is empty.
	 */
	boolean empty() {
		return this.size() == 0;
	}

	/**
	 * Sees if an object is on the stack.
	 * 
	 * @param o
	 *            the desired object
	 * @return the distance from the top, or -1 if it is not found.
	 */
	int search(int o) {
		for (int i = this.size() - 1; i >= 0; i--) {
			int item = this.get(i);
			if (item == o) {
				return this.size() - i - 1;
			}
		}
		return -1;
	}
}

public class UE16Aufgabe5 {

	// kleines Testprogramm
	public static void main(String[] args) {
		MyStack stack = new MyStack();
		for (int i = 0; i < 5; i++) {
			stack.push(IO.readInt("Eingabe: "));
		}

		int check = IO.readInt("Check: ");
		IO.println("Abstand = " + stack.search(check));

		while (!stack.isEmpty()) {
			IO.println(stack.pop());
		}

	}

}
